Name:           ocaml-lwt
Version:        2.4.2
Release:        %mkrel 5
Summary:        Cooperative light-weight thread library for OCaml
Group:          Development/OCaml
License:        LGPLv2+ with exceptions
URL:            http://ocsigen.org/lwt/
Source0:        http://ocsigen.org/download/lwt-%{version}.tar.gz
Patch0:         lwt-2.4.2-ocaml-4.patch
BuildRequires:  ocaml-compiler
BuildRequires:  ocaml-compiler-libs
BuildRequires:  ocaml-findlib
BuildRequires:  camlp4
BuildRequires:  camlp4-devel
BuildRequires:  ocaml-ssl
BuildRequires:  ocaml-react-devel
BuildRequires:  ocaml-text
BuildRequires:  ncurses-devel
BuildRequires:  libev-devel
BuildRequires:  pkgconfig(glib-2.0)
Requires:  camlp4
Requires:  ocaml-react
Requires:  ocaml-ssl
Requires:  ocaml-text
Requires:  libev-devel

%description
Lwt is a lightweight thread library for OCaml.
This library of cooperative threads is implemented in monadic style.
With respect to preemptive threads, cooperative threads are not using a
scheduler to distribute processor time between threads. Instead of this,
each thread must tell the others that he wants to let them work.
This library is part of the Ocsigen project.

%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}
Requires:  camlp4-devel
Requires:  ocaml-findlib-devel
Requires:  ocaml-react-devel
Requires:  ocaml-ssl-devel
Requires:  ocaml-text-devel
Requires:  pkgconfig(glib-2.0)

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%package doc
Summary:        Documentation for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}

%description doc
The %{name}-doc package contains documentation for %{name}.

%prep
%setup -q -n lwt-%{version}
%patch0 -p1

mv README README.old
iconv -f iso-8859-1 -t utf-8 < README.old > README

%build
# ev.h is in /usr/include/libev
export C_INCLUDE_PATH=/usr/include/libev
ocaml setup.ml -configure \
  --prefix %{_prefix} --destdir '%{buildroot}' --docdir %{_docdir}/%{name}-doc/ \
  --enable-ssl --enable-react --enable-glib --enable-text
# Fix hardcoded library path
sed -i 's|"/lib"|"/%{_lib}"|g' myocamlbuild.ml
make
make doc

%install
rm -rf %{buildroot}
export OCAMLFIND_DESTDIR=%{buildroot}%{_libdir}/ocaml
mkdir -p $OCAMLFIND_DESTDIR $OCAMLFIND_DESTDIR/stublibs
make install
mv examples/ %{buildroot}%{_docdir}/%{name}-doc/

%files
%doc LICENSE COPYING CHANGES README
%dir %{_libdir}/ocaml/lwt
%{_libdir}/ocaml/lwt/META
%{_libdir}/ocaml/lwt/*.cma
%{_libdir}/ocaml/lwt/*.cmi
%{_libdir}/ocaml/lwt/*.cmxs
%{_libdir}/ocaml/stublibs/*.so*

%files devel
%doc tests/
%{_libdir}/ocaml/lwt/*.a
%{_libdir}/ocaml/lwt/*.h
%{_libdir}/ocaml/lwt/*.ml
%{_libdir}/ocaml/lwt/*.cmxa
%{_libdir}/ocaml/lwt/*.cmx
%{_libdir}/ocaml/lwt/*.mli

%files doc
%{_docdir}/%{name}-doc/


%changelog

* Sun Jan 13 2013 umeabot <umeabot> 2.4.2-5.mga3
+ Revision: 361451
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 01 2012 malo <malo> 2.4.2-4.mga3
+ Revision: 324096
- rebuild for new ocaml

* Sat Oct 20 2012 malo <malo> 2.4.2-3.mga3
+ Revision: 308590
- update RPM group

* Tue Oct 02 2012 blue_prawn <blue_prawn> 2.4.2-2.mga3
+ Revision: 302107
- adapt the Fedora patch (by Richard W.M. Jones and Scott Tsai) for lwt 2.4.2
- uported patch for ocaml 4.00 from Fedora
- build requires ocaml-compiler-libs
- rebuild for new ocaml 4.00

* Sat Sep 29 2012 blue_prawn <blue_prawn> 2.4.2-1.mga3
+ Revision: 300203
- updated to last version 2.4.2
- new rpm group for ocaml and documentation

* Sat Aug 25 2012 blue_prawn <blue_prawn> 2.4.1-1.mga3
+ Revision: 283978
- updated to last version 2.4.1
- also provide examples/ and tests/

* Thu Aug 02 2012 blue_prawn <blue_prawn> 2.4.0-1.mga3
+ Revision: 278022
- updated to last version 2.4.0

* Thu Mar 29 2012 malo <malo> 2.3.2-3.mga2
+ Revision: 227415
- missing requires libev-devel

* Tue Jan 31 2012 malo <malo> 2.3.2-2.mga2
+ Revision: 203728
- fix hardcoded lib path for x86_64

* Thu Dec 22 2011 malo <malo> 2.3.2-1.mga2
+ Revision: 186096
- missing BuildRequires ocaml-react-devel
- spec clean-up after import
- missing requires
- update to 2.3.2
- imported package ocaml-lwt

